'====================================================================
#include "windows.bi"
#include "counter.bas"
'====================================================================
'' Counter.bas is available here:
''
'' http://www.freebasic.net/forum/viewtopic.php?t=4221
'====================================================================

FUNCTION Paul(byval sNum as zstring ptr) AS LONG  ' you must terminate passed string with a $NUL

  asm

    mov edi,[sNum]                 ' get the pointer to the string
    XOR edx,edx                    ' the SUM =0
    XOR ecx,ecx                    ' the NEG flag =0
                                   '
    movzx eax,BYTE PTR [edi]       ' get the first character

  lp:
    cmp eax,48L                     ' is character < a "0"?
    jl  LessThan0                   ' yes, skip to the non-digit check
    cmp eax,57L                     ' is it greater than a "9"?
    jg  NextCharacter               ' yes, get next char.

    'to get here it must be a digit '
    imul edx,10L                    ' sum=sum*10 ..
    ADD edx,eax                     '     + digit
    SUB edx,48L                     '     - 48
    jmp NextCharacter               '

   LessThan0:
    cmp eax,46                     ' is it a "."
    je done                        ' yes, then exit loop
    cmp eax,45                     ' is it a "-"
    jne NextCharacter              ' no, get next character
    mov ecx,1                      ' set the NEG flag

  NextCharacter:

    inc edi                        ' increment the string pointer
    movzx eax,BYTE PTR [edi]       ' get next character
    OR eax,eax                     ' test if zero
    jnz lp                         ' not zero, go back and do next character

  done:

    cmp ecx,0                      ' is NEG flag set?
    je skip                        ' no, skip next instruction
    neg edx                        ' yes, negate answer
                                   '
  skip:
    mov [FUNCTION],edx             ' WRITE answer TO FUNCTION

  end asm

END FUNCTION  ' End Paul function

'====================================================================

dim as integer i
dim sz as zstring * 9

sz = "12345678"

sleep 3000

const NLOOPS = 1000

counter_begin( NLOOPS, HIGH_PRIORITY_CLASS )
  i = Paul(@sz)
counter_end
print counter_cycles

counter_begin( NLOOPS, HIGH_PRIORITY_CLASS )
  i = Paul(@sz)
counter_end
print counter_cycles

counter_begin( NLOOPS, HIGH_PRIORITY_CLASS )
  i = Paul(@sz)
counter_end
print counter_cycles

sleep
